--- old/usr/src/cmd/awk_xpg4/Makefile	2017-09-04 19:55:56.732694602 +0000
+++ new/usr/src/cmd/awk_xpg4/Makefile	2017-09-04 19:55:56.745658302 +0000
@@ -70,8 +70,8 @@
 
 install: all $(ROOTXPG4PROG)
 
-values-xpg4.o: ../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+values-xpg4.o: ../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
 clean:
 	$(RM) $(OBJS) $(XPG4) $(CLEANFILES)
--- old/usr/src/cmd/cron/Makefile	2017-09-04 19:55:57.267419861 +0000
+++ new/usr/src/cmd/cron/Makefile	2017-09-04 19:55:57.280067316 +0000
@@ -181,8 +181,8 @@
 objs.xpg4:
 	-@mkdir -p $@
 
-objs.xpg4/values-xpg4.o:	../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+objs.xpg4/values-xpg4.o:	../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
 %.o:			$(SRC)/common/util/%.c
 	$(COMPILE.c) $(OUTPUT_OPTION) $<
--- old/usr/src/cmd/date/Makefile	2017-09-04 19:55:57.777886554 +0000
+++ new/usr/src/cmd/date/Makefile	2017-09-04 19:55:57.795224593 +0000
@@ -20,8 +20,6 @@
 # CDDL HEADER END
 #
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
-#
 # Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
@@ -48,8 +46,8 @@
 
 install: all $(ROOTPROG) $(ROOTXPG4PROG)
 
-values-xpg4.o: ../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+values-xpg4.o: ../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
 clean:
 	$(RM) $(OBJS)
--- old/usr/src/cmd/ed/Makefile	2017-09-04 19:55:58.309518436 +0000
+++ new/usr/src/cmd/ed/Makefile	2017-09-04 19:55:58.322640922 +0000
@@ -103,11 +103,11 @@
 	$(RM) $(ROOTBIN)/red
 	$(LN) $(ROOTBIN)/ed $(ROOTBIN)/red
 
-values-xpg4.o: ../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+values-xpg4.o: ../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
-values-xpg6.o: ../../lib/common/common/values-xpg6.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg6.c
+values-xpg6.o: ../../lib/crt/common/values-xpg6.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg6.c
 
 clean:
 	-@rm -rf $(OBJS) $(XPG4) $(XPG6) edobjs.xpg4 edobjs.xpg6 \
--- old/usr/src/cmd/ed/inc.flg	2017-09-04 19:55:58.690001087 +0000
+++ new/usr/src/cmd/ed/inc.flg	2017-09-04 19:55:58.702509060 +0000
@@ -24,9 +24,6 @@
 # Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
 
 echo_file usr/src/cmd/expr/compile.c
 echo_file usr/src/cmd/expr/mapfile-intf
-echo_file usr/src/lib/common/common/values-xpg4.c
-echo_file usr/src/lib/common/common/values-xpg6.c
--- old/usr/src/cmd/env/Makefile	2017-09-04 19:55:59.058131345 +0000
+++ new/usr/src/cmd/env/Makefile	2017-09-04 19:55:59.070596630 +0000
@@ -23,8 +23,6 @@
 # Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 PROG= env
 XPG4PROG= env
@@ -44,8 +42,8 @@
 
 install: all $(ROOTPROG) $(ROOTXPG4PROG)
 
-values-xpg4.o: ../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+values-xpg4.o: ../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
 clean:
 	$(RM) $(OBJS)
--- old/usr/src/cmd/getconf/Makefile	2017-09-04 19:55:59.577739460 +0000
+++ new/usr/src/cmd/getconf/Makefile	2017-09-04 19:55:59.590110843 +0000
@@ -111,8 +111,8 @@
 
 install: all $(ROOTPROG) $(ROOTXPG4PROG) $(ROOTXPG6PROG)
 
-values-xpg4.o: ../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+values-xpg4.o: ../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
 clean:
 	-@rm -rf $(OBJS) $(XPG4EXOBJS) $(XPG6EXOBJS) $(X4) $(X6) \
--- old/usr/src/cmd/link/Makefile	2017-09-04 19:56:00.054132581 +0000
+++ new/usr/src/cmd/link/Makefile	2017-09-04 19:56:00.065904844 +0000
@@ -50,8 +50,8 @@
 	-$(RM) $(ROOTETCPROG)
 	-$(SYMLINK) ../usr/sbin/$(PROG) $(ROOTETCPROG)
 
-values-xpg4.o: ../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+values-xpg4.o: ../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
 clean:
 	$(RM) $(OBJS)
--- old/usr/src/cmd/mv/Makefile	2017-09-04 19:56:00.547990092 +0000
+++ new/usr/src/cmd/mv/Makefile	2017-09-04 19:56:00.559585775 +0000
@@ -76,8 +76,8 @@
 	$(COMPILE.c) -o $@ $<
 	$(POST_PROCESS_O)
 
-%values-xpg4.o:		../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+%values-xpg4.o:		../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
 $(CPFILE):	$(PROG)
 	@$(RM) $(CPFILE); $(LN) $(PROG) $(CPFILE)
--- old/usr/src/cmd/nice/Makefile	2017-09-04 19:56:01.040058646 +0000
+++ new/usr/src/cmd/nice/Makefile	2017-09-04 19:56:01.052284400 +0000
@@ -23,8 +23,6 @@
 # Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 PROG= nice
 XPG4PROG= nice
@@ -45,8 +43,8 @@
 
 install: all $(ROOTPROG) $(ROOTXPG4PROG)
 
-values-xpg4.o: ../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../lib/common/common/values-xpg4.c
+values-xpg4.o: ../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../lib/crt/common/values-xpg4.c
 
 clean:
 	$(RM) $(OBJS)
--- old/usr/src/cmd/sgs/0@0/amd64/Makefile	2017-09-04 19:56:01.517505228 +0000
+++ new/usr/src/cmd/sgs/0@0/amd64/Makefile	2017-09-04 19:56:01.530026550 +0000
@@ -23,10 +23,8 @@
 # Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
-CRTSRCS =	$(SRC)/lib/common/amd64
+CRTSRCS =	$(SRC)/lib/crt/amd64
 
 include		$(SRC)/cmd/sgs/0@0/Makefile.com
 
--- old/usr/src/cmd/sgs/0@0/i386/Makefile	2017-09-04 19:56:01.907199702 +0000
+++ new/usr/src/cmd/sgs/0@0/i386/Makefile	2017-09-04 19:56:01.921747071 +0000
@@ -23,9 +23,8 @@
 # Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
 
-CRTSRCS=        $(SRC)/lib/common/i386
+CRTSRCS=        $(SRC)/lib/crt/i86
 include		$(SRC)/cmd/sgs/0@0/Makefile.com
 
 .KEEP_STATE:
--- old/usr/src/cmd/sgs/0@0/sparc/Makefile	2017-09-04 19:56:02.288839829 +0000
+++ new/usr/src/cmd/sgs/0@0/sparc/Makefile	2017-09-04 19:56:02.303806371 +0000
@@ -23,9 +23,8 @@
 # Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
 
-CRTSRCS=	$(SRC)/lib/common/sparc
+CRTSRCS=	$(SRC)/lib/crt/sparcv7
 
 include		$(SRC)/cmd/sgs/0@0/Makefile.com
 
--- old/usr/src/cmd/sgs/0@0/sparcv9/Makefile	2017-09-04 19:56:02.678496891 +0000
+++ new/usr/src/cmd/sgs/0@0/sparcv9/Makefile	2017-09-04 19:56:02.691451609 +0000
@@ -23,9 +23,8 @@
 # Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
 
-CRTSRCS=        $(SRC)/lib/common/sparcv9
+CRTSRCS=        $(SRC)/lib/crt/sparcv9
 include		$(SRC)/cmd/sgs/0@0/Makefile.com
 
 .KEEP_STATE:
--- old/usr/src/cmd/sgs/rtld/amd64/Makefile	2017-09-04 19:56:03.057539280 +0000
+++ new/usr/src/cmd/sgs/rtld/amd64/Makefile	2017-09-04 19:56:03.070119297 +0000
@@ -48,7 +48,7 @@
 
 S_ASOBJS=	
 
-CRTSRCS=	../../../../lib/common/amd64
+CRTSRCS=	../../../../lib/crt/amd64
 CRTI=		pics/crti.o
 CRTN=		pics/crtn.o
 CRTS=		$(CRTI)		$(CRTN)
--- old/usr/src/cmd/sgs/rtld/i386/Makefile	2017-09-04 19:56:03.431438936 +0000
+++ new/usr/src/cmd/sgs/rtld/i386/Makefile	2017-09-04 19:56:03.444453961 +0000
@@ -48,7 +48,7 @@
 
 S_ASOBJS=
 
-CRTSRCS=	../../../../lib/common/i386
+CRTSRCS=	../../../../lib/crt/i86
 CRTI=		pics/crti.o
 CRTN=		pics/crtn.o
 CRTS=		$(CRTI)		$(CRTN)
--- old/usr/src/cmd/sgs/rtld/sparc/Makefile	2017-09-04 19:56:03.816131141 +0000
+++ new/usr/src/cmd/sgs/rtld/sparc/Makefile	2017-09-04 19:56:03.828862442 +0000
@@ -47,7 +47,7 @@
 
 S_ASOBJS=	boot_a.out.o
 
-CRTSRCS=	../../../../lib/common/sparc
+CRTSRCS=	../../../../lib/crt/sparcv7
 CRTI=		pics/crti.o
 CRTN=		pics/crtn.o
 CRTS=		$(CRTI)		$(CRTN)
--- old/usr/src/cmd/sgs/rtld/sparcv9/Makefile	2017-09-04 19:56:04.178697318 +0000
+++ new/usr/src/cmd/sgs/rtld/sparcv9/Makefile	2017-09-04 19:56:04.191090036 +0000
@@ -46,7 +46,7 @@
 
 S_ASOBJS=	
 
-CRTSRCS=	../../../../lib/common/sparcv9
+CRTSRCS=	../../../../lib/crt/sparcv9
 CRTI=		pics/crti.o
 CRTN=		pics/crtn.o
 CRTS=		$(CRTI)		$(CRTN)
--- old/usr/src/cmd/vi/port/Makefile	2017-09-04 19:56:04.545065644 +0000
+++ new/usr/src/cmd/vi/port/Makefile	2017-09-04 19:56:04.558201773 +0000
@@ -117,11 +117,11 @@
 $(XD4)/compile.o $(XD6)/compile.o: ../../expr/compile.c
 	$(COMPILE.c) -o $@ ../../expr/compile.c
 
-%values-xpg4.o: ../../../lib/common/common/values-xpg4.c
-	$(COMPILE.c) -o $@ ../../../lib/common/common/values-xpg4.c
+%values-xpg4.o: ../../../lib/crt/common/values-xpg4.c
+	$(COMPILE.c) -o $@ ../../../lib/crt/common/values-xpg4.c
 
-%values-xpg6.o: ../../../lib/common/common/values-xpg6.c
-	$(COMPILE.c) -o $@ ../../../lib/common/common/values-xpg6.c
+%values-xpg6.o: ../../../lib/crt/common/values-xpg6.c
+	$(COMPILE.c) -o $@ ../../../lib/crt/common/values-xpg6.c
 
 $(XPG4EXOBJS): $(XD4)
 
--- old/usr/src/cmd/vi/port/inc.flg	2017-09-04 19:56:04.919886616 +0000
+++ new/usr/src/cmd/vi/port/inc.flg	2017-09-04 19:56:04.929593812 +0000
@@ -24,10 +24,6 @@
 # Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 echo_file usr/src/cmd/expr/compile.c
-echo_file usr/src/lib/common/common/values-xpg4.c
-echo_file usr/src/lib/common/common/values-xpg6.c
-echo_file usr/src/lib/libc/inc/xpg6.h
+
--- old/usr/src/lib/Makefile	2017-09-04 19:56:05.305517008 +0000
+++ new/usr/src/lib/Makefile	2017-09-04 19:56:05.318381686 +0000
@@ -43,7 +43,7 @@
 
 # Build libc and its dependencies
 SUBDIRS=			\
-	common			\
+	crt			\
 	../cmd/sgs/libconv	\
 	../cmd/sgs/libdl	\
 	libc			\
@@ -548,8 +548,8 @@
 _dc:			$(DCSUBDIRS:%=%-nodepend)
 
 # Library interdependencies are called out explicitly here.
-../cmd/sgs/libconv: common
-../cmd/sgs/libdl: common
+../cmd/sgs/libconv: crt
+../cmd/sgs/libdl: crt
 libc:		../cmd/sgs/libconv ../cmd/sgs/libdl
 
 libm:		libc
--- /dev/null	2017-09-04 19:56:06.000000000 +0000
+++ new/usr/src/lib/crt/Makefile	2017-09-04 19:56:06.577435331 +0000
@@ -0,0 +1,45 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License, Version 1.0 only
+# (the "License").  You may not use this file except in compliance
+# with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+#
+# Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+
+include	../Makefile.lib
+
+SUBDIRS = $(MACH32)
+$(BUILD64)SUBDIRS += $(MACH64)
+
+all :=		TARGET= all
+install :=	TARGET= install
+clean :=	TARGET= clean
+clobber :=	TARGET= clobber
+lint :=		TARGET= lint
+
+.KEEP_STATE:
+
+all install clean clobber lint: $(SUBDIRS)
+
+$(SUBDIRS):	FRC
+	@cd $@; pwd; $(MAKE) $(TARGET)
+
+FRC:
--- /dev/null	2017-09-04 19:56:06.000000000 +0000
+++ new/usr/src/lib/crt/Makefile.com	2017-09-04 19:56:06.972674445 +0000
@@ -0,0 +1,98 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+#
+# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+
+CRTI = crti.o
+CRTN = crtn.o
+CRT1 = crt1.o
+VALUES = values-Xa.o values-Xc.o values-Xs.o values-Xt.o \
+		values-xpg4.o values-xpg6.o
+COMMON_CRT = common-crt.o
+MACH_CRT = mach-crt1.o
+
+# include library definitions
+include ../../Makefile.lib
+
+SRCS = $(VALUES:%.o=../common/%.c) $(COMMON_CRT:%.o=../common/%.c)
+
+POST_PROCESS_O = $(PROCESS_COMMENT) $@ ; $(STRIP) -x $@
+
+OBJECTS = $(VALUES) $(CRT1) $(CRTI) $(CRTN)
+
+ROOTLIB=	$(ROOT)/usr/lib
+ROOTLIB64=	$(ROOTLIB)/$(MACH64)
+ROOTOBJECTS=	$(OBJECTS:%=$(ROOTLIB)/%)
+ROOTOBJECTS64=	$(OBJECTS:%=$(ROOTLIB64)/%)
+
+$(INTEL_BLD)ROOTOBJECTS += $(ROOTLIB)/gcrt1.o
+$(INTEL_BLD)ROOTOBJECTS64 += $(ROOTLIB64)/gcrt1.o
+
+ASFLAGS +=	-P -D__STDC__ -D_ASM -DPIC $(AS_PICFLAGS)
+
+values-xpg6.o := CPPFLAGS += -I$(SRC)/lib/libc/inc
+values-xpg6.lint := CPPFLAGS += -I$(SRC)/lib/libc/inc
+$(COMMON_CRT) $(VALUES) := CFLAGS += $(C_PICFLAGS)
+$(COMMON_CRT) $(VALUES) := CFLAGS64 += $(C_PICFLAGS64)
+
+.KEEP_STATE:
+
+all:	$(OBJECTS)
+
+clean clobber:
+	$(RM) $(OBJECTS)
+
+%.lint: ../common/%.c
+	$(LINT.c) $(LINTCHECKFLAGS) $<
+
+lint:	$(VALUES:%.o=%.lint) $(COMMON_CRT:%.o=%.lint)
+
+$(CRT1): $(COMMON_CRT) $(MACH_CRT)
+	$(LD) -r $(MACH_CRT) $(COMMON_CRT) -o $(CRT1)
+
+%.o:	../common/%.c
+	$(COMPILE.c) -o $@ $<
+	$(POST_PROCESS_O)
+
+%.o:	%.s
+	$(COMPILE.s) -o $@ $<
+	$(POST_PROCESS_O)
+
+%.o:	../$(MACH)/%.s
+	$(COMPILE.s) -o $@ $<
+	$(POST_PROCESS_O)
+
+# install rule for ROOTOBJECTS and ROOTOBJECTS64
+$(ROOTLIB)/%.o: %.o
+	$(INS.file)
+
+$(ROOTLIB)/gcrt1.o:
+	$(RM) $(ROOTLIB)/gcrt1.o; $(SYMLINK) crt1.o $(ROOTLIB)/gcrt1.o
+
+$(ROOTLIB64)/%.o: %.o
+	$(INS.file)
+
+$(ROOTLIB64)/gcrt1.o:
+	$(RM) $(ROOTLIB64)/gcrt1.o; $(SYMLINK) crt1.o $(ROOTLIB64)/gcrt1.o
+
+FRC:
--- /dev/null	2017-09-04 19:56:06.000000000 +0000
+++ new/usr/src/lib/crt/amd64/Makefile	2017-09-04 19:56:07.164422536 +0000
@@ -0,0 +1,30 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License, Version 1.0 only
+# (the "License").  You may not use this file except in compliance
+# with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+#
+# Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+
+include ../Makefile.com
+include ../../Makefile.lib.64
+
+install:	$(ROOTOBJECTS64)
--- /dev/null	2017-09-04 19:56:06.000000000 +0000
+++ new/usr/src/lib/crt/amd64/crti.s	2017-09-04 19:56:07.586960921 +0000
@@ -0,0 +1,58 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+	.file	"crti.s"
+
+/*
+ * These crt*.o modules are provided as the bare minimum required
+ * from a crt*.o for inclusion in building low level system
+ * libraries.  The are only be to included in libraries which
+ * contain *no* C++ code and want to avoid the startup code
+ * that the C++ runtime has introduced into the crt*.o modules.
+ *
+ * For further details - see bug#4433015
+ */
+
+/*
+ * _init function prologue
+ */
+	.section	.init,"ax"
+	.globl	_init
+	.type	_init,@function
+	.align	16
+_init:
+	pushq	%rbp
+	movq	%rsp, %rbp
+
+/*
+ * _fini function prologue
+ */
+	.section	.fini,"ax"
+	.globl	_fini
+	.type	_fini,@function
+	.align	16
+_fini:	
+	pushq	%rbp
+	movq	%rsp, %rbp
--- /dev/null	2017-09-04 19:56:06.000000000 +0000
+++ new/usr/src/lib/crt/amd64/crtn.s	2017-09-04 19:56:07.788352529 +0000
@@ -0,0 +1,50 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+	.file	"crtn.s"
+
+/*
+ * These crt*.o modules are provided as the bare minimum required
+ * from a crt*.o for inclusion in building low level system
+ * libraries.  The are only be to included in libraries which
+ * contain *no* C++ code and want to avoid the startup code
+ * that the C++ runtime has introduced into the crt*.o modules.
+ *
+ * For further details - see bug#4433015
+ */
+
+/*
+ * _init function epilogue
+ */
+	.section	.init,"ax"
+	leave
+	ret
+
+/*
+ * _fini function epilogue
+ */
+	.section	.fini,"ax"
+	leave
+	ret
--- /dev/null	2017-09-04 19:56:08.000000000 +0000
+++ new/usr/src/lib/crt/amd64/mach-crt1.s	2017-09-04 19:56:07.984522571 +0000
@@ -0,0 +1,98 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#include <sys/asm_linkage.h>
+
+	.file	"mach-crt1.s"
+
+	.global	_start_crt
+
+/*
+ *   The SVR4/i386 ABI (pages 3-29) says that when the entry
+ *   point runs registers' %rbp, %rsp, %rdx values are specified
+ *   the following:
+ *
+ *	%rbp The content of this register is unspecified at
+ *		process initialization time, but the user code should mark
+ *		the deepest stack frame by setting the frame pointer to zero.
+ *		No other frame's %ebp should have a zero value.
+ *
+ *	%rsp Performing its usual job, the stack pointer holds the address
+ *	of the bottom of the stack, which is guaranteed to be
+ *	quadword aligned.
+ *
+ *		The stack contains the arguments and environment:
+ *	  ...
+ *	  envp[0]		(16+(8*argc))(%rsp)
+ *	  NULL			(8+(8*argc))(%rsp)
+ *	  ...
+ *	  argv[0]		8(%rsp)
+ *	  argc			0(%rsp)
+ *
+ *	%rdx In a conforming program, this register contains a function
+ *		pointer that the application should register with atexit(BA_OS).
+ *		This function is used for shared object termination code
+ *		[see Dynamic Linking in Chapter 5 of the System V ABI].
+ *
+ */
+
+ENTRY_NP(_start)
+/*
+ * Allocate a NULL return address and a NULL previous %rbp as if
+ * there was a genuine call to _start.
+ */
+	pushq	$0
+	pushq	$0
+	movq	%rsp,%rbp		/* The first stack frame */
+
+/*
+ * The stack now is
+ *
+ *	  envp[0]		(32+(8*argc))(%rsp)	 - (A)
+ *	  NULL			(24+(8*argc))(%rsp)
+ *	  ...
+ *	  argv[0]		24(%rbp)		 - (B)
+ *	  argc			16(%rbp)
+ *	  0			8(%rbp)
+ *	  0			0(%rbp)
+ */
+
+	andq	$-16,%rsp		/* align the stack */
+	movq	16(%rbp),%rdi		/* argc */
+	leaq	24(%rbp),%rsi		/* argv */
+	/* NB: rt_do_exit, if applicable, is already in %rdx */
+	call	_start_crt
+	hlt
+SET_SIZE(_start)
+
+/*
+ * The following is here in case any object module compiled with cc -p
+ *	was linked into this module.
+ */
+ENTRY_NP(_mcount)
+	.weak	_mcount
+	ret
+SET_SIZE(_mcount)
--- /dev/null	2017-09-04 19:56:08.000000000 +0000
+++ new/usr/src/lib/crt/common/common-crt.c	2017-09-04 19:56:08.181097417 +0000
@@ -0,0 +1,100 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016, Richard Lowe.
+ */
+
+/*
+ * That of the CRT startup routine which itself may be implemented in C.
+ */
+
+#include <sys/feature_tests.h>
+#include <sys/types.h>
+
+#include <stdlib.h>
+#include <synch.h>
+#include <unistd.h>
+
+#pragma weak _DYNAMIC
+extern uintptr_t _DYNAMIC;
+
+#pragma weak environ = _environ
+char **_environ = NULL;
+char **___Argv = NULL;
+
+extern int main(int argc, char **argv, char **envp);
+extern void _init(void);
+extern void _fini(void);
+
+#pragma weak _start_crt_compiler
+extern void _start_crt_compiler(int argc, char **argv);
+
+#if defined(__x86)
+int __longdouble_used = 0;
+extern void __fpstart(void);
+#endif
+
+#if defined(__i386)		/* Not amd64 */
+#pragma weak __fsr_init_value
+extern long __fsr_init_value;
+extern void __fsr(uintptr_t);
+#endif
+
+
+/*
+ * Defined here for ABI reasons, must match the definition in libc.
+ * If it cannot, a new symbol must be created.
+ */
+mutex_t __environ_lock = DEFAULTMUTEX;
+
+void
+_start_crt(int argc, char **argv, void (*exit_handler)(void))
+{
+	int ret = 0;
+
+	/*
+	 * On x86, we check whether we're a dynamic executable to see whether
+	 * we'll receive an exit_handler.
+	 *
+	 * On SPARC, we just need to check whether the handler was NULL.
+	 */
+#if defined(__x86)
+	if (&_DYNAMIC != NULL)
+		(void) atexit(exit_handler);
+#elif defined(__sparc)
+	if (exit_handler != NULL)
+		(void) atexit(exit_handler);
+#endif
+
+	(void) atexit(_fini);
+
+	_environ = argv + (argc + 1);
+	___Argv = argv;
+
+	if (&_start_crt_compiler != NULL)
+		_start_crt_compiler(argc, argv);
+
+#if defined(__x86)
+	__fpstart();
+#endif
+#if defined(__i386) 		/* Not amd64 */
+	/*
+	 * Note that Studio cc(1) sets the _value of the symbol_, that is, its
+	 * address.  Not the value _at_ that address.
+	 */
+	__fsr((uintptr_t)&__fsr_init_value);
+#endif
+	_init();
+	ret = main(argc, argv, _environ);
+	exit(ret);
+	_exit(ret);
+}
--- /dev/null	2017-09-04 19:56:08.000000000 +0000
+++ new/usr/src/lib/crt/common/values-Xa.c	2017-09-04 19:56:08.378394061 +0000
@@ -0,0 +1,43 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*	Copyright (c) 1988 AT&T	*/
+/*	  All Rights Reserved  	*/
+
+
+#include <sys/types.h>
+#include <math.h>
+
+/*
+ * variables which differ depending on the
+ * compilation mode
+ *
+ * ANSI conforming mode
+ * This file is linked into the a.out immediately following
+ * the startup routine if the -Xa compilation mode is selected
+ */
+
+const enum version _lib_version = ansi_1;
--- /dev/null	2017-09-04 19:56:08.000000000 +0000
+++ new/usr/src/lib/crt/common/values-Xc.c	2017-09-04 19:56:08.794316945 +0000
@@ -0,0 +1,43 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*	Copyright (c) 1988 AT&T	*/
+/*	  All Rights Reserved  	*/
+
+
+#include <sys/types.h>
+#include <math.h>
+
+/*
+ * variables which differ depending on the
+ * compilation mode
+ *
+ * Strict ANSI mode
+ * This file is linked into the a.out immediately following
+ * the startup routine if the -Xc compilation mode is selected
+ */
+
+const enum version _lib_version = strict_ansi;
--- /dev/null	2017-09-04 19:56:08.000000000 +0000
+++ new/usr/src/lib/crt/common/values-Xs.c	2017-09-04 19:56:09.202028328 +0000
@@ -0,0 +1,45 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*	Copyright (c) 1988 AT&T	*/
+/*	  All Rights Reserved  	*/
+
+
+#include <sys/types.h>
+#include <math.h>
+
+/*
+ * variables which differ depending on the
+ * compilation mode
+ *
+ * C Issue 4.2 compatibility mode
+ * This file is linked into the a.out by default if
+ * no compilation mode was specified or if the -Xt option
+ * was specified - the linking occurs if there is an unresolved
+ * reference to _lib_version
+ */
+
+const enum version _lib_version = c_issue_4;
--- /dev/null	2017-09-04 19:56:08.000000000 +0000
+++ new/usr/src/lib/crt/common/values-Xt.c	2017-09-04 19:56:09.597996095 +0000
@@ -0,0 +1,45 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*	Copyright (c) 1988 AT&T	*/
+/*	  All Rights Reserved  	*/
+
+
+#include <sys/types.h>
+#include <math.h>
+
+/*
+ * variables which differ depending on the
+ * compilation mode
+ *
+ * C Issue 4.2 compatibility mode
+ * This file is linked into the a.out by default if
+ * no compilation mode was specified or if the -Xt option
+ * was specified - the linking occurs if there is an unresolved
+ * reference to _lib_version
+ */
+
+const enum version _lib_version = c_issue_4;
